#include <sys/types.h>
#include <v7libc_internal.h>

#define NULL ((void *)0)
extern void	*malloc();


struct linux_dirent {
	unsigned long	d_ino;
	unsigned long	d_off;
	unsigned short	d_reclen;
	char		d_name[1];
};

#define size 1024

typedef struct state_s {
	char buff[size];
	int next; /* index in buffer where next entry to return starts */
	int last; /* index in buffer for the last valid byte from the syscall + 1 */
	int fd;
	_v7libc_dirent_t de;
} state_t;


void _v7libc_dirstart(void **cookie, int fd)
{
	state_t **state = (state_t **)cookie;
	*state = malloc(sizeof(state_t));
	(*state)->next = (*state)->last = 0;
	(*state)->fd = fd;
}

void _v7libc_dirend(void **cookie)
{
	state_t **state = (state_t **)cookie;
	free(*state);
	*state = NULL;
}


_v7libc_dirent_t *_v7libc_dirnext(void *cookie)
{
	struct linux_dirent *d;
	state_t *state = cookie;
	int len, nextent;

	if (state->next >= state->last)
		goto preread;

	d = (struct linux_dirent *)(state->buff + state->next);
	nextent = state->next + d->d_reclen;

	if (nextent >= size - sizeof(struct linux_dirent)) {
		len = state->last - state->next;
		state->last = len;
		if (len > 0) {
			char *si, *so;
			/* poor man's memmove() */
			for(si = state->buff+state->next, so = state->buff; len > 0; len--, si++, so++)
				*so = *si;
		}
		state->next = 0;
		preread:;
		len = _v7libc_getdents(state->fd, state->buff + state->last, size - state->last);
		if (len <= 0)
			return NULL;
		state->last += len;
		d = (struct linux_dirent *)(state->buff + state->next);
		nextent = state->next + d->d_reclen;
	}


	state->de.ino = d->d_ino;
	state->de.name = (char *)d->d_name;

	if (nextent >= state->last) {
		state->last = 0;
		state->next = 0;
	}
	else
		state->next = nextent;
	return &(state->de);
}
