#include <errno.h>
#include <time.h>
#include <sys/types.h>
#include <sys/syscall.h>

#define NULL ((void *)0)
extern int errno;

struct timeval
  {
    time_t tv_sec;		/* Seconds.  */
    long int tv_usec;	/* Microseconds.  */
  };

int stime(const time_t *newtime)
{
	struct timeval tv;

	if (newtime == NULL) {
		errno = EINVAL;
		return -1;
	}
	tv.tv_sec = *newtime;
	tv.tv_usec = 0;
	return syscall(SYS_settimeofday, &tv, (void *) 0);
}
